      program pdgr03b

c     pdgr03b is another version of pdgr03 and is applicable
c     to a large-sized (N > 500,000) data set.

      include 'pdgr03.inc'
      integer iv(0:3),im(2*mx_ind,2)
      real*8 rand

      open(99,file='pdgr_uncompleted.txt')
      open(98,file='pdgr.txt')
      open(97,file='pdgr_suppl1.txt')
      open(96,file='pdgr_suppl2_1.txt')
      open(95,file='pdgr_suppl2_2.txt')
      open(94,file='pdgr_error.txt')

      open(93,file='pdgr_id.txt')

*     write(*,*) 'Please input 0 here if the data set'
*     write(*,*) 'includes founder(s) in the 1st column'
*     write(*,*) '(ID) and 1 (or another number) otherwise.
*     read(*,*) is1

      nr_prt=0
      do i=0,mx_ind
       do j=1,5
        id(i,j)=0
       enddo
      enddo
      do i=1,mx_ind
       do j=1,2
        im(i,j)=0
       enddo
      enddo

c     The data set is input and duplicates are removed.

      read(99,*) (iv(i),i=1,3)
      n_find=iv(1)
      iv(0)=0
      backspace(99)
1     read(99,*,end=2) (iv(i),i=1,3)
      if(id(iv(1),1).ne.0) then
       if(iv(2).ne.id(iv(1),2).or.iv(3).ne.id(iv(1),3))
     >    write(94,'(6i10)') (id(iv(1),j),j=1,3)
     >                      ,(iv(i),i=1,3)
      else
       do i=1,3
        id(iv(1),i)=iv(i)
       enddo
       id(iv(0),4)=iv(1)
*      id(iv(1),4)=0
       iv(0)=iv(1)

       do i=2,3
        if(iv(i).ne.0.and.im(iv(i),1).eq.0) then
         im(iv(i),1)=iv(i)
         nr_prt=nr_prt+1
         im(nr_prt,2)=iv(i)
        endif
       enddo
      endif
3     goto 1
2     continue

c     -----------------------------------------

      do i=1,nr_prt
       if(id(im(i,2),1).eq.0) then
        id(im(i,2),1)=im(i,2)
        id(im(i,2),2)=0
        id(im(i,2),3)=0
        id(im(i,2),4)=n_find
        n_find=im(i,2)
       endif
      enddo

      nr_ind=0
4     iv(1)=n_find
      do while(iv(1).ne.0)
       do i=2,3
        iv(i)=id(iv(1),i)
        if(iv(i).ne.0.and.id(iv(i),4).gt.-1) goto 5
       enddo
       nr_ind=nr_ind+1
       id(iv(1),5)=nr_ind

       write(98,'(2i10)') (id(iv(i),5),i=2,3)
       write(97,'(i10)') id(iv(1),1)
*      write(97,'(2i10)') id(iv(1),5),id(iv(1),1)
       if(id(iv(1),1).lt.10000) then
        write(96,'(a1,i10,a1,i10,a1)') '+',id(iv(1),1)
     >                                ,'*',id(iv(1),5),'#'
        write(96,'(a2)') '++'
        write(96,'(a2)') '**'
       else
        write(95,'(a1,i10,a1,i10,a1)') '+',id(iv(1),1)
     >                                ,'*',id(iv(1),5),'#'
        write(95,'(a2)') '++'
        write(95,'(a2)') '**'
       endif
       write(93,'(4i10)') (id(iv(1),i),i=1,3),nr_ind

       if(iv(1).ne.n_find) then
        id(iv(0),4)=id(iv(1),4)
        id(iv(1),4)=-9
        iv(1)=id(iv(0),4)
       else
        n_find=id(iv(1),4)
        id(iv(1),4)=-9
        iv(1)=n_find
       endif
       goto 6

5      iv(0)=iv(1)
       iv(1)=id(iv(1),4)
6      continue
      enddo
      if(n_find.ne.0) goto 4

c     -----------------------------------------

      rewind(93)
      i=0
      do j=1,nr_ind
       read(93,*) (id(j,k),k=1,4)
       call r_uni(rand,i)
       id(j,5)=int(mx_ind*rand)+1
      enddo

      call qsrt(5,1)
      call qsrt(1,0)

      rewind(93)
      do i=1,nr_ind
       write(93,'(4i10)') (id(i,j),j=1,4)
      enddo

      stop
      end

c     ########################################

      subroutine qsrt(is1,is2)

      include 'pdgr03.inc'
      integer pivot,n_feis(mx_ind),n_leis(mx_ind)

*     nr_ccl=0

      nr_sbv=1
      n_feis(1)=1
      n_leis(1)=nr_ind
      do i=2,nr_ind
       n_feis(i)=0
       n_leis(i)=0
      enddo

c     -----------------------------------------

      do while(nr_sbv.lt.nr_ind)
       nr_dsv=0  ! No. of divided subvectors
       do i=1,nr_sbv
        if(n_leis(i)-n_feis(i).lt.1) goto 3
        pivot=max(id(n_feis(i),is1),id(n_feis(i)+1,is1))

        is3=n_feis(i)
        is4=n_leis(i)
4       continue
        do while(id(is3,is1).lt.pivot.and.
     >           is3.lt.n_leis(i))
         is3=is3+1
        enddo
        do while(id(is4,is1).gt.pivot.and.
     >           is4.gt.n_feis(i))
         is4=is4-1
        enddo
        if(is3.lt.is4) then
         is5=id(is3,is1)
         id(is3,is1)=id(is4,is1)
         id(is4,is1)=is5
         if(is2.gt.0) then
          is5=id(is3,is2)
          id(is3,is2)=id(is4,is2)
          id(is4,is2)=is5
         endif
         do j=2,4
          is5=id(is3,j)
          id(is3,j)=id(is4,j)
          id(is4,j)=is5
         enddo

         is3=is3+1
         is4=is4-1
         goto 4
        else
         nr_dsv=nr_dsv+1
         n_leis(nr_sbv+nr_dsv)=n_leis(i)
         n_leis(i)=is3-1
         n_feis(nr_sbv+nr_dsv)=is3
        endif
3       continue
       enddo
       nr_sbv=nr_sbv+nr_dsv

*      if(nr_sbv.ge.nr_ccl) then
*       call gettim(ihr,imin,isec,i100th)
*       time2=60.d0*(60.d0*ihr+imin)+isec+i100th/100.d0
*       write(*,'(i10,f16.8)') nr_sbv,time2-time1
*       nr_ccl=nr_ccl+nr_itv
*      endif
      enddo

      return
      end

c     ########################################

      subroutine r_uni(z,tan)
      integer l,c,t30,tan
      real*8 mu,z
      parameter(l=843314861,c=453816693,t30=2**30,
     >          mu=2.0**31)

      tan=l*tan+c
      if(tan.lt.0) tan=(tan+t30)+t30
      z=dble(tan)/mu
      return
      end
